
if (Sys.info()[['user']] == 'shiny'){
  Sys.setenv(RETICULATE_PYTHON = "/usr/bin/python3")
}
library(shiny);library(reticulate);library(crypto2);library(dplyr);library(geckor);library(coinmarketcapr);library(tidyr);library(anytime);library(RJSONIO);library(beepr)
#library(XRPython);library(forecastHybrid);library(dplyr);library(forecast);library(bsts);library(nnfor)

################   Shiny   ##################

ui.robotnob4<- navbarPage("Robot-Nobitex New by Dr. M. Jabbari Nooghabi (BUY)",
                          tabPanel("Reading Priminarly Values",
                                   sidebarLayout(sidebarPanel(
                                     				 textInput("token","Token:",""),
                                     #				 textInput("pass1","Password:",""),
                                     #                textInput("curr1","Currency for Balance:",""),
                                     #                numericInput("days1","Days for History:",5),
                                     #                uiOutput("currency_selects"),
                                     #                actionButton("goButton","Run Data",class="btn-success"),
                                     textInput("curr2","curr2:","dot"),
                                     textInput("curr3","curr3:","usdt"),
                                     numericInput("rangebox","Range of Boxplot:",1.5),
                                     numericInput("wait.low","Minumum wait time:",200),
                                     numericInput("wait.up","Maximum wait time:",210)
                                   ),
                                   mainPanel(uiOutput("tb1"))        
                                   )),
                          tabPanel("Reading Secondary Values",
                                   sidebarLayout(sidebarPanel(
                                     textInput("symbol","Currency for Symbol:",'DOTUSDT'),
                                     numericInput("break.time","Break Time:",5220),
                                     numericInput("buy0","Minimum Level of Buy:",16),
                                     submitButton("Run Model",icon("sync")),
                                     numericInput("percentbuy","Percent of Buy:",0.02),
                                     numericInput("percentsell","Percent of Sell:",0.02),
                                     numericInput("amountbuy","Amount of Buy:",1),
                                     numericInput("amountsell","Amount of Sell:",1),
                                     numericInput("h","h (Amount plus or minus):",0.001)
                                   ),
                                   mainPanel(helpText("The Results"),
                                             verbatimTextOutput("out"),
                                             verbatimTextOutput("out1"),
                                             #verbatimTextOutput("out1")
                                   ))
                          ))

server.robotnob4<- function(input,output){
  output$out <- renderPrint({
    
    print("################################################################")
    py_run_string("import requests")
    print(py_module_available("requests"))
    py_run_string("import json")
    print(py_module_available("json"))
    print("################################################################")
  })
  output$out1 <- renderPrint({
    py$symbol=input$symbol;py$src_curr=input$curr2;py$curr2=input$curr2;py$curr3=input$curr3;py$h=input$h
    py$url=paste0('https://api.nobitex.ir/v2/orderbook/',py$symbol)
    py$url1="https://api.nobitex.ir/users/wallets/balance"
    py$url2="https://api.nobitex.ir/market/orders/add"
    py$url3="https://api.nobitex.ir/market/orders/status"
    py$payload={};py$files={};py$headers={};py$amountbuy=input$amountbuy;py$amountsell=input$amountsell;
    py$Token=paste0('Token ',input$token)
    i=j=1;buy=sell=bal1=bal2=py$idbuy=py$idsell=c();sell[1]=input$buy0/(1-input$percentbuy);buyconfirm=sellconfirm=1
    while(as.numeric(format(Sys.time(),"%d%H%M"))<input$break.time){
      print(c("i=",i,"j=",j))
      print("###############################################")
      if(as.numeric(format(Sys.time(),"%d%H%M"))>=input$break.time) break
      py_run_string("order_book1=requests.get(url,headers=headers,data=payload,files=files)")
      ordask=matrix(as.numeric(unlist(fromJSON(py$order_book1$text)$ask)),nc=2,byrow=T);ordbids=matrix(as.numeric(unlist(fromJSON(py$order_book1$text)$bids)),nc=2,byrow=T)
      if(any(ordask[,2]%in%boxplot(ordask[,2],range=input$rangebox,plot=F)$out))ordaskout<-matrix(ordask[ordask[,2]%in%boxplot(ordask[,2],range=input$rangebox,plot=F)$out,],nc=2);if(any(ordbids[,2]%in%boxplot(ordbids[,2],range=input$rangebox,plot=F)$out))ordbidsout<-matrix(ordbids[ordbids[,2]%in%boxplot(ordbids[,2],range=input$rangebox,plot=F)$out,],nc=2)
      print(rep("*",19));print(c("ordask[1,1]",ordask[1,1],"ordbids[1,1]",ordbids[1,1],"Diff",abs(ordbids[1,1]-ordask[1,1])/ordask[1,1]))
      print(rep("*",19));print(rbind(c("ordask-rank","ordaskout-price","ordaskout-amount"),cbind(which(ordask[,2]%in%ordaskout),ordaskout)))
      print(rep("$",19));print(rbind(c("ordbids-rank","ordbidsout-price","ordbidsout-amount"),cbind(which(ordbids[,2]%in%ordbidsout),ordbidsout)));if(!is.null(ordaskout)&!is.null(ordbidsout))print(c("Diff Out",abs(ordbidsout[1,1]-ordaskout[1,1])/ordaskout[1,1]))
      py_run_string("bal2=requests.post(url1,headers={'Authorization': Token},data={'currency':curr3},files=files)");
      bal2=as.numeric(fromJSON(py$bal2$text)[2]);print(c("Balance,",input$curr3,bal2))
      py_run_string("bal1=requests.post(url1,headers={'Authorization': Token},data={'currency':curr2},files=files)");
      bal1=as.numeric(fromJSON(py$bal1$text)[2]);print(c("Balance,",input$curr2,bal1));print(rep("*",19));print(Sys.time())
      if(i<=j&buyconfirm==1&dim(ordaskout)[1]>=dim(ordbidsout)[1])if(ordask[1,1]<=(1-input$percentbuy)*sell[j]){
        py$pricebuy=ordask[1,1]+input$h
        if(as.numeric(fromJSON(py$bal2$text)[2])>input$amountbuy*1.011*ordask[1,1]){
          py_run_string("add_order_buy=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'buy', 'srcCurrency':curr2,'dstCurrency':curr3,'amount':amountbuy,'price':pricebuy}))");
          print(c("Status of Buy",py$add_order_buy$text))
          if(fromJSON(py$add_order_buy$text)[1]=='ok'){
            buy<-c(buy,py$pricebuy);print(c("OK Order of Buy",i,buy[i],"Time=",format(Sys.time(),"%d%m%y-%H%M")));beep(sound=2);print(rep("*",19))
            py$idbuy=fromJSON(py$add_order_buy$text)$order$id
          }}}
      if(i<=j&!is.null(py$idbuy)){
        py_run_string("statusbuy=requests.post(url3,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'id': idbuy}))")
        if(fromJSON(py$statusbuy$text)$order$status=='Done'){
          print("OK Buy Confirmed");beep(sound=2);beep(sound=1);i=i+1;print(rep("*",19))
          buyconfirm=1;py$idbuy=c()}else buyconfirm=0}
      if(j<i&sellconfirm==1&dim(ordaskout)[1]<=dim(ordbidsout)[1])if(ordbids[1,1]>=(1+input$percentsell)*buy[i-1]){
        py$pricesell=ordbids[1,1]-input$h
        if(as.numeric(fromJSON(py$bal1$text)[2])>input$amountsell*1.011){
          py_run_string("add_order_sell=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'sell', 'srcCurrency':curr2,'dstCurrency':curr3,'amount':amountsell,'price':pricesell}))");
          print(c("Status of Sell",py$add_order_sell$text))
          if(fromJSON(py$add_order_sell$text)[1]=='ok'){
            sell<-c(sell,py$pricesell);print(c("OK Order of Sell",j+1,sell[j+1],"Time=",format(Sys.time(),"%d%m%y-%H%M")));beep(sound=3);print(rep("*",19))
            py$idsell=fromJSON(py$add_order_sell$text)$order$id
          }}}
      if(j<i&!is.null(py$idsell)){
        py_run_string("statussell=requests.post(url3,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'id': idsell}))")
        if(fromJSON(py$statussell$text)$order$status=='Done'){
          print("OK Sell Confirmed");beep(sound=3);beep(sound=1);j=j+1;print(rep("*",19))
          sellconfirm=1;py$idsell=c()}else sellconfirm=0}
      if(j>=2){print(rep("#",19));print(c("Interest(%)=",abs(sell[j]-buy[i-1])/buy[i-1]*100));print(rep("#",19))}
      if(as.numeric(format(Sys.time(),"%d%H%M"))>=input$break.time) break
      Sys.sleep(round(runif(1,input$wait.low,input$wait.up)))
    }
    print(rbind(buy,sell))
  })
}

shinyApp(ui.robotnob4,server.robotnob4)


