#install.packages("bsts",rep="https://cran.um.ac.ir/")
#library(openxlsx)
library(shiny);library(reticulate);library(RJSONIO);library(beepr)
#library(XRPython);library(forecastHybrid);library(dplyr);library(forecast);library(bsts);library(nnfor)

################   Shiny   ##################
#py_install(packages="requests",pip=T)
py_run_string("import requests")
py_module_available("requests")
py_run_string("import json")
py_module_available("json")
#########################################

ui.robotnob46<- navbarPage("Robot-Nobitex New by Dr. M. Jabbari Nooghabi (BUY)-R6",
                tabPanel("Reading Priminarly Values",
                					sidebarLayout(sidebarPanel(
#				 textInput("user1","User:",""),
#				 textInput("pass1","Password:",""),
				 textInput("token","Token:",""),
#                textInput("curr1","Currency for Balance:",""),
#                numericInput("days1","Days for History:",5),
#                uiOutput("currency_selects"),
#                actionButton("goButton","Run Data",class="btn-success"),
	             textInput("curr1","curr1:","dot"),
	             textInput("curr2","curr2:","usdt"),
                 numericInput("outnumber","Order of Outliers:",2),
                 numericInput("rangebox","Range of Boxplot:",1.5),
                 numericInput("wait.low","Minumum wait time:",200),
                 numericInput("wait.up","Maximum wait time:",250)
                                                            ),
				 mainPanel(uiOutput("tb1"))        
                          )),
                tabPanel("Reading Secondary Values",
				 sidebarLayout(sidebarPanel(
                numericInput("break.time","Break Time (ddhhmm):",32200),
                numericInput("buy0","Minimum Level of Buy:",16),
				 submitButton("Run Model",icon("sync")),
				 numericInput("percentbuy","Percent of Buy:",0.02),
                numericInput("percentsell","Percent of Sell:",0.02),
                numericInput("percentbuy1","Percent of Buy-1:",0.015),
                numericInput("percentsell1","Percent of Sell-1:",0.015),
                numericInput("percentbuy2","Percent of Buy-2:",0.010),
                numericInput("percentsell2","Percent of Sell-2:",0.010),
                numericInput("expecthour1","Expected Hour of Buy/Sell-1:",2),
                numericInput("expecthour2","Expected Hour of Buy/Sell-2:",3),
                numericInput("amountbuy","Amount of Buy:",1.8),
                numericInput("amountsell","Amount of Sell:",1.8),
                numericInput("amountpercent","Percent Amount of Buy/Sell:",0.8),
                 numericInput("h","h (Amount plus or minus):",0.001)
			               ),
				mainPanel(helpText("The Results"),
                verbatimTextOutput("out"),
				 textOutput("out1")
                #verbatimTextOutput("out1")
                          			))
                ))

server.robotnob46<- function(input,output){
output$out <- renderPrint({

print("################################################################")
py_run_string("import requests")
print(py_module_available("requests"))
py_run_string("import json")
print(py_module_available("json"))
print("################################################################")
})
#data=c()
output$out1 <- renderText({
#if(input$pass1=='JAB@30'){
py$symbol=toupper(paste0(input$curr1,input$curr2));py$curr1=input$curr1;py$curr2=input$curr2;py$h=input$h
py$url=paste0('https://api.nobitex.ir/v2/orderbook/',py$symbol)
py$url1="https://api.nobitex.ir/users/wallets/balance"
py$url2="https://api.nobitex.ir/market/orders/add"
py$url3="https://api.nobitex.ir/market/orders/status"
py$payload={};py$files={};py$headers={};
py$Token=paste('Token',input$token)
py$Token='Token 735de2ceef8e514fb14c91602b4ead383c97ac4e'
i=j=1;buy=sell=bal1=bal2=py$idbuy=py$idsell=systime=criticalbuy=criticalsell=c();sell[1]=input$buy0/(1-input$percentbuy);buyconfirm=sellconfirm=1;newbuy1=newbuy2=newsell1=newsell2=F
repeat{
#ordask=ordbids=matrix();ordask[1,1]=runif(1,27,29);ordbids[1,1]=runif(1,ordask[1,1]+0.1,29)
print(rep("@",19));print(paste("BUY Index, i=",i,", Amount of BUY=",input$amountbuy,", Critical Buy=",criticalbuy,", Minimum Value of Buy 0=",input$buy0));print(paste("SELL Index, j=",j,", Amount of SELL=",input$amountsell,", Critical Sell=",criticalsell))
print("0 ################################################################################################################")
if(as.numeric(format(Sys.time(),"%d%H%M"))>=input$break.time) break
try(py_run_string("order_book1=requests.get(url,headers=headers,data=payload,files=files)"))
ordask=matrix(as.numeric(unlist(fromJSON(py$order_book1$text)$ask)),nc=2,byrow=T);ordbids=matrix(as.numeric(unlist(fromJSON(py$order_book1$text)$bids)),nc=2,byrow=T)
#data=rbind(data,cbind(ordask,ordbids));write.csv(data,"D:/SHINY/Boors/Forecasting coinmarketcap-without API-crypto2-geckor-Nobitex/out-orders.csv")
ordaskbox=boxplot(ordask[,2],range=input$rangebox,plot=F)$out;ordbidsbox=boxplot(ordbids[,2],range=input$rangebox,plot=F)$out
if(length(ordaskbox)==0|length(ordbidsbox)==0){ordaskbox=boxplot(ordask[,2],range=0.5,plot=F)$out;ordbidsbox=boxplot(ordbids[,2],range=0.5,plot=F)$out}
if(any(ordask[,2]%in%ordaskbox))ordaskout<-matrix(ordask[ordask[,2]%in%ordaskbox,],nc=2);if(any(ordbids[,2]%in%ordbidsbox))ordbidsout<-matrix(ordbids[ordbids[,2]%in%ordbidsbox,],nc=2)
ordaskrank=which(ordask[,2]%in%ordaskout);ordbidsrank=which(ordbids[,2]%in%ordbidsout)
print(rep("*",19));print(paste("ordask[1,1]=",ordask[1,1],", ordbids[1,1]=",ordbids[1,1],", Percent Diff (%)=",abs(ordbids[1,1]-ordask[1,1])/ordask[1,1]*100))
print(rep("*",19));print(rbind(c("ordask-rank","ordaskout-price","ordaskout-amount"),cbind(ordaskrank,ordaskout)))
print(rep("$",19));print(rbind(c("ordbids-rank","ordbidsout-price","ordbidsout-amount"),cbind(ordbidsrank,ordbidsout)));if(!is.null(ordaskout)&!is.null(ordbidsout))print(paste("Percent Diff Out (%)=",abs(ordbidsout[1,1]-ordaskout[1,1])/ordaskout[1,1]*100))
#try(py_run_string("bal2=requests.post(url1,headers={'Authorization': Token},data={'currency':curr2},files=files)"))
#bal2=as.numeric(fromJSON(py$bal2$text)[2]);print(paste("Balance,",input$curr2,"=",bal2))
#try(py_run_string("bal1=requests.post(url1,headers={'Authorization': Token},data={'currency':curr1},files=files)"))
#bal1=as.numeric(fromJSON(py$bal1$text)[2]);print(paste("Balance,",input$curr1,"=",bal1));
print(rep("*",19));print(paste("Current Time=",format(Sys.time(),"%d%m%y-%H%M")))
systime=c(systime,as.numeric(format(Sys.time(),"%d%H%M")));difftime=diff(range(systime))
print(paste("Time Passed=",difftime,", Expected Hour-1*100=",input$expecthour1*100,", Expected Hour-2*100=",input$expecthour2*100))
print("1 ################################################################################################################")
if(i<=j&newbuy1==F&difftime>=input$expecthour1*100&difftime<input$expecthour2*100){print("NEW-BUY-1");criticalbuy=(1-input$percentbuy1)*sell[j];print(paste("criticalbuy, NEW-BUY-1=",criticalbuy));beep(sound=11);newbuy1=T}
if(i<=j&newbuy2==F&difftime>=input$expecthour2*100){print("NEW-BUY-2");criticalbuy=(1-input$percentbuy2)*sell[j];print(paste("criticalbuy, NEW-BUY-2=",criticalbuy));beep(sound=13);newbuy2=T}
if(newbuy1==F&newbuy2==F)criticalbuy=(1-input$percentbuy)*sell[j]
if(i<=j&buyconfirm==1&(dim(ordaskout)[1]>=dim(ordbidsout)[1]|ordaskrank[1]<=input$outnumber))if(ordask[1,1]<=criticalbuy){
py$pricebuy=ordask[1,1]+input$h
#if(as.numeric(fromJSON(py$bal2$text)[2])>input$amountbuy*1.011*ordask[1,1])py$amountbuy=input$amountbuy else py$amountbuy=round(input$amountbuy*input$amountpercent,1)
py$amountbuy=input$amountbuy
try(py_run_string("add_order_buy=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'buy', 'srcCurrency':curr1,'dstCurrency':curr2,'amount':amountbuy,'price':pricebuy}))"))
if(fromJSON(py$add_order_buy$text)[2]=="OverValueOrder"){py$amountbuy=round(input$amountbuy*input$amountpercent,1)
try(py_run_string("add_order_buy=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'buy', 'srcCurrency':curr1,'dstCurrency':curr2,'amount':amountbuy,'price':pricebuy}))"));print(paste("Status of Buy=",py$add_order_buy$text))}
print(paste("Status of Buy=",py$add_order_buy$text))
if(fromJSON(py$add_order_buy$text)[1]=='ok'){
print("2 ################################################################################################################")
buy<-c(buy,py$pricebuy);print(paste("OK Order of Buy,",i,"=",buy[i],", Time=",format(Sys.time(),"%d%m%y-%H%M")));beep(sound=2);print(rep("*",19))
py$idbuy=factor(fromJSON(py$add_order_buy$text)$order$id)
}}
if(i<=j&!is.null(py$idbuy)){
print("3 ################################################################################################################")
try(py_run_string("statusbuy=requests.post(url3,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'id': idbuy}))"))
print(paste("Order of Buy Status=",fromJSON(py$statusbuy$text)$order$status))
if(fromJSON(py$statusbuy$text)$order$status=='Done'){
print("4 ################################################################################################################")
print("OK Buy Confirmed");beep(sound=2);beep(sound=1);i=i+1;systime=c();difftime=0;print(rep("*",19))
buyconfirm=1;py$idbuy=c();newbuy1=F;newbuy2=F}else buyconfirm=0}
print("5 ################################################################################################################")
if(j<i&newsell1==F&difftime>=input$expecthour1*100&difftime<input$expecthour2*100){print("NEW-SELL-1");criticalsell=(1+input$percentsell1)*buy[i-1];print(paste("criticalsell, NEW-SELL-1=",criticalsell));beep(sound=11);newsell1=T}
if(j<i&newsell2==F&difftime>=input$expecthour2*100){print("NEW-SELL-2");criticalsell=(1+input$percentsell2)*buy[i-1];print(paste("criticalsell, NEW-SELL-2=",criticalsell));beep(sound=13);newsell2=T}
if(newsell1==F&newsell2==F)criticalsell=(1+input$percentsell)*buy[i-1]
print("6 ################################################################################################################")
if(j<i&sellconfirm==1&(dim(ordaskout)[1]<=dim(ordbidsout)[1]|ordbidsrank[1]<=input$outnumber))if(ordbids[1,1]>=criticalsell){
py$pricesell=ordbids[1,1]-input$h
#if(as.numeric(fromJSON(py$bal1$text)[2])>input$amountsell*1.011)py$amountsell=input$amountsell else py$amountsell=round(input$amountsell*input$amountpercent,1)
py$amountsell=input$amountsell
try(py_run_string("add_order_sell=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'sell', 'srcCurrency':curr1,'dstCurrency':curr2,'amount':amountsell,'price':pricesell}))"))
print("7 ################################################################################################################")
if(fromJSON(py$add_order_sell$text)[2]=="OverValueOrder"){py$amountsell=round(input$amountsell*input$amountpercent,1)
try(py_run_string("add_order_sell=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'sell', 'srcCurrency':curr1,'dstCurrency':curr2,'amount':amountsell,'price':pricesell}))"));print(paste("Status of Sell=",py$add_order_sell$text))}
print(paste("Status of Sell=",py$add_order_sell$text))
if(fromJSON(py$add_order_sell$text)[1]=='ok'){
sell<-c(sell,py$pricesell);print(paste("OK Order of Sell,",j+1,"=",sell[j+1],", Time=",format(Sys.time(),"%d%m%y-%H%M")));beep(sound=3);print(rep("*",19))
py$idsell=factor(fromJSON(py$add_order_sell$text)$order$id)
}}
if(j<i&!is.null(py$idsell)){
print("8 ################################################################################################################")
try(py_run_string("statussell=requests.post(url3,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'id': idsell}))"))
print(paste("Order of Sell Status=",fromJSON(py$statussell$text)$order$status))
if(fromJSON(py$statussell$text)$order$status=='Done'){
print("9 ################################################################################################################")
print("OK Sell Confirmed");beep(sound=3);beep(sound=1);j=j+1;systime=c();difftime=0;print(rep("*",19))
sellconfirm=1;py$idsell=c();newsell1=F;newsell2=F}else sellconfirm=0}
if(j>=2){print(rep("#",19));print(paste("Interest (%)=",abs(sell[j]-buy[i-1])/buy[i-1]*100));print(rep("#",19))}
if(as.numeric(format(Sys.time(),"%d%H%M"))>=input$break.time) break
print("10 ################################################################################################################")
Sys.sleep(round(runif(1,input$wait.low,input$wait.up)))
}
print(rbind(buy,sell))
#} else print("Password is not CORRECT")
})
}

shinyApp(ui.robotnob46,server.robotnob46)
beep(sound=12);Sys.sleep(5);beep(sound=13)

