library(shiny);library(reticulate);library(RJSONIO);library(beepr)

#########################################
py_run_string("import requests")
print(py_module_available("requests"))
py_run_string("import json")
print(py_module_available("json"))
#########################################
rm(list = ls())
ui.robotnob7 <- navbarPage("Robot-Nobitex NewNew by Dr. M. Jabbari Nooghabi (BUY)-R7",
  tabPanel("Reading Priminarly Values",
            sidebarLayout(sidebarPanel(
#				 textInput("pass1","Password:",""),
				 textInput("token","Token:",""),
	             textInput("curr1","curr1:","dot"),
	             textInput("curr2","curr2:","usdt"),
                 numericInput("outnumber","Order of Outliers:",3),
                 numericInput("rangebox","Range of Boxplot:",1),
                 numericInput("wait.low","Minumum wait time (Second):",120),
                 numericInput("wait.up","Maximum wait time (Second):",125)
                                      ),
    mainPanel(uiOutput("tb1"))        
            )),
  tabPanel("Reading Secondary Values",
    		 sidebarLayout(sidebarPanel(
                 uiOutput("stop"),
                 numericInput("break.time","Break Time (ddhhmm):",322300),
                 numericInput("buy0","Minimum Level of Buy:",18),
                 actionButton("goButton", "Run", class = "btn-success"),
				 numericInput("percentbuy","Percent of Buy:",0.02),
                 numericInput("percentsell","Percent of Sell:",0.02),
                 numericInput("percentbuy1","Percent of Buy-1:",0.015),
                 numericInput("percentsell1","Percent of Sell-1:",0.015),
                 numericInput("percentbuy2","Percent of Buy-2:",0.01),
                 numericInput("percentsell2","Percent of Sell-2:",0.01),
                 numericInput("expecthour1","Expected Hour of Buy/Sell-1:",2),
                 numericInput("expecthour2","Expected Hour of Buy/Sell-2:",3),
                 numericInput("amountbuy","Amount of Buy:",1.8),
                 numericInput("amountsell","Amount of Sell:",1.8),
                 numericInput("amountpercent","Percent Amount of Buy/Sell:",0.8),
                 numericInput("h","h (Amount plus or minus):",0.002)
			               ),
    mainPanel(helpText("The Results"),
        verbatimTextOutput("out")
            ))
         ))

server.robotnob7 <- function(input, output, session) {
  curr1 <- eventReactive(input$goButton, input$curr1)
  curr2 <- eventReactive(input$goButton, input$curr2)
  outnumber <- eventReactive(input$goButton, input$outnumber)
  rangebox <- eventReactive(input$goButton, input$rangebox)
  wait.low <- eventReactive(input$goButton, input$wait.low)
  wait.up <- eventReactive(input$goButton, input$wait.up)
output$stop<-renderUI({
   selectInput("stop","Select Response for STOP",choices=c("No"="No","Yes"="Yes"))
   })
  break.time <- eventReactive(input$goButton, input$break.time)
  buy0 <- eventReactive(input$goButton, input$buy0)
  percentbuy <- eventReactive(input$goButton, input$percentbuy)
  percentsell <- eventReactive(input$goButton, input$percentsell)
  percentbuy1 <- eventReactive(input$goButton, input$percentbuy1)
  percentsell1 <- eventReactive(input$goButton, input$percentsell1)
  percentbuy2 <- eventReactive(input$goButton, input$percentbuy2)
  percentsell2 <- eventReactive(input$goButton, input$percentsell2)
  expecthour1 <- eventReactive(input$goButton, input$expecthour1)
  expecthour2 <- eventReactive(input$goButton, input$expecthour2)
  amountbuy <- eventReactive(input$goButton, input$amountbuy)
  amountsell <- eventReactive(input$goButton, input$amountsell)
  amountpercent <- eventReactive(input$goButton, input$amountpercent)
  h <- eventReactive(input$goButton, input$h)
py$idbuy=py$idsell=py$add_order_buy=py$add_order_sell=c()
  rv <- reactiveValues(lines = character(0),time=0,stop=0,No=0,i=1,j=1,systime=c(),buy=c(),sell=c(),idbuy=c(),idsell=c(),criticalbuy=c(),criticalsell=c(),buyconfirm=1,sellconfirm=1,newbuy1=F,newbuy2=F,newsell1=F,newsell2=F,add_order_buy=c(),BUYCONFIRM=c(),SELLCONFIRM=c())

  observe({
rv$sell[1]=buy0()/(1-percentbuy())
#py$idbuy=rv$idbuy;py$idsell=rv$idsell;py$add_order_buy=rv$add_order_buy
py$symbol=toupper(paste0(curr1(),curr2()));py$curr1=curr1();py$curr2=curr2();py$h=h();
py$url=paste0('https://api.nobitex.ir/v2/orderbook/',py$symbol)
py$url1="https://api.nobitex.ir/users/wallets/balance"
py$url2="https://api.nobitex.ir/market/orders/add"
py$url3="https://api.nobitex.ir/market/orders/status"
py$payload={};py$files={};py$headers={};
py$Token=paste('Token',input$token)
# py$Token='Token 735de2ceef8e514fb14c91602b4ead383c97ac4e'
    invalidateLater(round(runif(1,wait.low()*1000,wait.up()*1000)), session) # = 1e3 ms sys.time
    isolate({
rv$stop<-input$stop
#if(input$pass1=='JAB@30'){
if(rv$time >= break.time() | rv$stop=="Yes")rv$lines<-list(paste("Time is OVER or STOP",",  Time=",rv$time,",  rv$stop=",rv$stop),rv$lines)
      if (rv$time >= break.time() | rv$stop=="Yes") {
        return()
        } else {
print(rep("@",19));print(paste("BUY Index, i=",rv$i,", Amount of BUY=",amountbuy(),", Critical Buy=",rv$criticalbuy,", Minimum Value of Buy 0=",buy0()));print(paste("SELL Index, j=",rv$j,", Amount of SELL=",amountsell(),", Critical Sell=",rv$criticalsell))
print("0 ################################################################################################################")
try(py_run_string("order_book1=requests.get(url,headers=headers,data=payload,files=files)"))
print(py$order_book1)
#ordask=ordbids=matrix();ordask=cbind(sort(runif(24,16,20),decreasing=T),runif(24,0.1,150));ordbids=cbind(sort(runif(24,ordask[1,1]+0.3,22)),runif(24,0.1,170))
ordask=matrix(as.numeric(unlist(fromJSON(py$order_book1$text)$ask)),nc=2,byrow=T);ordbids=matrix(as.numeric(unlist(fromJSON(py$order_book1$text)$bids)),nc=2,byrow=T)
ordaskbox=boxplot(ordask[,2],range=rangebox(),plot=F)$out;ordbidsbox=boxplot(ordbids[,2],range=rangebox(),plot=F)$out
if(length(ordaskbox)==0|length(ordbidsbox)==0){ordaskbox=boxplot(ordask[,2],range=0.4,plot=F)$out;ordbidsbox=boxplot(ordbids[,2],range=0.4,plot=F)$out}
if(any(ordask[,2]%in%ordaskbox))ordaskout<-matrix(ordask[ordask[,2]%in%ordaskbox,],nc=2);if(any(ordbids[,2]%in%ordbidsbox))ordbidsout<-matrix(ordbids[ordbids[,2]%in%ordbidsbox,],nc=2)
ordaskrank=which(ordask[,2]%in%ordaskout);ordbidsrank=which(ordbids[,2]%in%ordbidsout)
print(rep("*",19));print(paste("ordask[1,1]=",ordask[1,1],", ordbids[1,1]=",ordbids[1,1],", Percent Diff (%)=",abs(ordbids[1,1]-ordask[1,1])/ordask[1,1]*100));print(rep("*",19));print(rbind(c("ordask-rank","ordaskout-price","ordaskout-amount"),cbind(ordaskrank,ordaskout)));print(rep("$",19));print(rbind(c("ordbids-rank","ordbidsout-price","ordbidsout-amount"),cbind(ordbidsrank,ordbidsout)));if(!is.null(ordaskout)&!is.null(ordbidsout))print(paste("Percent Diff Out (%)=",abs(ordbidsout[1,1]-ordaskout[1,1])/ordaskout[1,1]*100))
#try(py_run_string("bal2=requests.post(url1,headers={'Authorization': Token},data={'currency':curr2},files=files)"))
#if(!is.null(py$bal2))bal2=as.numeric(fromJSON(py$bal2$text)[2]);print(paste("Balance,",curr2(),"=",bal2))
#try(py_run_string("bal1=requests.post(url1,headers={'Authorization': Token},data={'currency':curr1},files=files)"))
#if(!is.null(py$bal1))bal1=as.numeric(fromJSON(py$bal1$text)[2]);print(paste("Balance,",curr1(),"=",bal1));print(rep("*",19));print(Sys.time())
print(paste("Current Time=",format(Sys.time(),"%Y-%m-%d, %H:%M:%S")))
rv$systime=c(rv$systime,as.numeric(format(Sys.time(),"%d%H%M")));difftime=diff(range(rv$systime))
print(paste("Time Passed=",difftime,", Expected Hour-1*100=",expecthour1()*100,", Expected Hour-2*100=",expecthour2()*100))
print("1 ################################################################################################################")
if(rv$i<=rv$j&rv$newbuy1==F&difftime>=expecthour1()*100&difftime<expecthour2()*100){rv$criticalbuy=(1-percentbuy1())*rv$sell[rv$j];beep(sound=11);rv$newbuy1=T;print("NEW-BUY-1");print(paste("criticalbuy, NEW-BUY-1=",rv$criticalbuy))}
if(rv$i<=rv$j&rv$newbuy2==F&difftime>=expecthour2()*100){rv$criticalbuy=(1-percentbuy2())*rv$sell[rv$j];beep(sound=13);rv$newbuy2=T;print("NEW-BUY-2");print(paste("criticalbuy, NEW-BUY-2=",rv$criticalbuy))}
if(rv$newbuy1==F&rv$newbuy2==F)rv$criticalbuy=(1-percentbuy())*rv$sell[rv$j]
if(rv$i<=rv$j&rv$buyconfirm==1&(dim(ordaskout)[1]>=dim(ordbidsout)[1]|ordaskrank[1]<=outnumber()))if(ordask[1,1]<=rv$criticalbuy){
py$pricebuy=ordask[1,1]+h()
#if(as.numeric(fromJSON(py$bal2$text)[2])>amountbuy()*1.011*ordask[1,1])py$amountbuy=amountbuy() else py$amountbuy=round(amountbuy()*amountpercent(),1)
py$amountbuy=amountbuy()
try(py_run_string("add_order_buy=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'buy', 'srcCurrency':curr1,'dstCurrency':curr2,'amount':amountbuy,'price':pricebuy}))"))
if(fromJSON(py$add_order_buy$text)[2]=="OverValueOrder"){py$amountbuy=round(amountbuy()*amountpercent(),1)
try(py_run_string("add_order_buy=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'buy', 'srcCurrency':curr1,'dstCurrency':curr2,'amount':amountbuy,'price':pricebuy}))"))}
print(paste("Status of Buy=",py$add_order_buy$text))
if(fromJSON(py$add_order_buy$text)[1]=='ok'){
print("2 ################################################################################################################")
rv$buy<-c(rv$buy,py$pricebuy);print(paste("Order of Buy,",rv$i,"=",rv$buy[rv$i],", Time=",format(Sys.time(),"%d%m%y-%H%M")));beep(sound=2);print(rep("*",19))
py$idbuy=factor(fromJSON(py$add_order_buy$text)$order$id)
}}
if(rv$i<=rv$j&!is.null(py$idbuy)){
print("3 ################################################################################################################")
try(py_run_string("statusbuy=requests.post(url3,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'id': idbuy}))"))
print(paste("Order of Buy Status=",fromJSON(py$statusbuy$text)$order$status))
if(fromJSON(py$statusbuy$text)$order$status=='Done'){
print("4 ################################################################################################################")
print("OK Buy Confirmed");rv$BUYCONFIRM="OK";beep(sound=2);beep(sound=1);rv$i=rv$i+1;rv$systime=c();difftime=0;print(rep("*",19))
rv$buyconfirm=1;py$idbuy=c();rv$newbuy1=F;rv$newbuy2=F}else rv$buyconfirm=0}
print("5 ################################################################################################################")
if(rv$j<rv$i&rv$newsell1==F&difftime>=expecthour1()*100&difftime<expecthour2()*100){rv$criticalsell=(1+percentsell1())*rv$buy[rv$i-1];beep(sound=11);rv$newsell1=T;print("NEW-SELL-1");print(paste("criticalsell, NEW-SELL-1=",rv$criticalsell))}
if(rv$j<rv$i&rv$newsell2==F&difftime>=expecthour2()*100){rv$criticalsell=(1+percentsell2())*rv$buy[rv$i-1];beep(sound=13);rv$newsell2=T;print("NEW-SELL-2");print(paste("criticalsell, NEW-SELL-2=",rv$criticalsell))}
if(rv$newsell1==F&rv$newsell2==F)rv$criticalsell=(1+percentsell())*rv$buy[rv$i-1]
print("6 ################################################################################################################")
if(rv$j<rv$i&rv$sellconfirm==1&(dim(ordaskout)[1]<=dim(ordbidsout)[1]|ordbidsrank[1]<=outnumber()))if(ordbids[1,1]>=rv$criticalsell){
py$pricesell=ordbids[1,1]-h()
#if(as.numeric(fromJSON(py$bal1$text)[2])>amountsell()*1.011)py$amountsell=amountsell() else py$amountsell=round(amountsell()*amountpercent(),1)
py$amountsell=amountsell()
try(py_run_string("add_order_sell=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'sell', 'srcCurrency':curr1,'dstCurrency':curr2,'amount':amountsell,'price':pricesell}))"))
print("7 ################################################################################################################")
if(fromJSON(py$add_order_sell$text)[2]=="OverValueOrder"){py$amountsell=round(amountsell()*amountpercent(),1)
try(py_run_string("add_order_sell=requests.post(url2,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'type':'sell', 'srcCurrency':curr1,'dstCurrency':curr2,'amount':amountsell,'price':pricesell}))"))}
print(paste("Status of Sell=",py$add_order_sell$text))
if(fromJSON(py$add_order_sell$text)[1]=='ok'){
rv$sell<-c(rv$sell,py$pricesell);print(paste("Order of Sell,",rv$j+1,"=",rv$sell[rv$j+1],", Time=",format(Sys.time(),"%d%m%y-%H%M")));beep(sound=3);print(rep("*",19))
py$idsell=factor(fromJSON(py$add_order_sell$text)$order$id)
}}
if(rv$j<rv$i&!is.null(py$idsell)){
print("8 ################################################################################################################")
try(py_run_string("statussell=requests.post(url3,headers={'Authorization': Token,'content-type':'application/json'},data=json.dumps({'id': idsell}))"))
print(paste("Order of Sell Status=",fromJSON(py$statussell$text)$order$status))
if(fromJSON(py$statussell$text)$order$status=='Done'){
print("9 ################################################################################################################")
print("OK Sell Confirmed");rv$SELLCONFIRM="OK";beep(sound=3);beep(sound=1);rv$j=rv$j+1;rv$systime=c();difftime=0;print(rep("*",19))
rv$sellconfirm=1;py$idsell=c();rv$newsell1=F;rv$newsell2=F}else rv$sellconfirm=0}
if(rv$j>=2){print(rep("#",19));print(paste("Interest (%)=",abs(rv$sell[rv$j]-rv$buy[rv$i-1])/rv$buy[rv$i-1]*100));print(rep("#",19))}
print("10 ################################################################################################################")

		rv$No <- rv$No+1
        rv$time <- as.numeric(format(Sys.time(),"%d%H%M"))
        rv$lines <- list(
paste("No.=",rv$No,",  Time=",rv$time,",  STOP=",rv$stop,",  ordask[1,1]=",ordask[1,1],",  ordbids[1,1]=",ordbids[1,1],",  Percent Diff (%)=",abs(ordbids[1,1]-ordask[1,1])/ordask[1,1]*100),
paste("BUY Index, i=",rv$i,",  Amount of BUY=",amountbuy(),",  Critical Buy=",rv$criticalbuy,",  Minimum Value of Buy0=",buy0()),
paste("SELL Index, j=",rv$j,",  Amount of SELL=",amountsell(),",  Critical Sell=",rv$criticalsell),
paste(t(rbind(c("ordask-rank   ","ordaskout-price   ","ordaskout-amount    "),cbind(ordaskrank,ordaskout)))),
paste(t(rbind(c("ordbids-rank","ordbidsout-price","ordbidsout-amount"),cbind(ordbidsrank,ordbidsout)))),
paste("Percent Diff Out (%)=",100*abs(ordbidsout[1,1]-ordaskout[1,1])/ordaskout[1,1]),
paste("Current Time=",Sys.time()),
paste("Time Passed=",difftime,",  Expected Hour-1*100=",expecthour1()*100,",  Expected Hour-2*100=",expecthour2()*100),
paste("criticalbuy, NEW-BUY-1=",rv$newbuy1,"%%%",rv$criticalbuy),
paste("criticalbuy, NEW-BUY-2=",rv$newbuy2,"%%%",rv$criticalbuy),
paste("Status of Buy=",py$add_order_buy$text),
paste("Order of Buy=",rv$i,", Value=",rv$buy[rv$i],",---Time=",format(Sys.time(),"%d%m%y-%H%M")),
paste("Buy Confirmed?=",rv$BUYCONFIRM),
paste("Buy Confirmed?=",rv$buyconfirm),
paste("criticalsell, NEW-SELL-1=",rv$newsell1,"%%%",rv$criticalsell),
paste("criticalsell, NEW-SELL-2=",rv$newsell2,"%%%",rv$criticalsell),
paste("Status of SELL=",py$add_order_sell$text),
paste("Order of SELL=",rv$j+1,", Value=",rv$sell[rv$j+1],"---Time=",format(Sys.time(),"%d%m%y-%H%M")),
paste("SELL Confirmed?=",rv$SELLCONFIRM),
paste("SELL Confirmed?=",rv$sellconfirm),
paste("####################################################################################################################################")

        ,rv$lines)
      }
#} else {print("Password is not CORRECT");rv$lines<-list(paste("Password is not CORRECT"),rv$lines)}
    })
  })

  output$out <- renderPrint({
    rv$lines
  })
  observeEvent(input$goButton, rv$time <- 0);observeEvent(input$goButton, rv$lines <- character(0))
  observeEvent(input$goButton, rv$No <- 0);observeEvent(input$goButton, rv$stop<- 0)
}

shinyApp(ui.robotnob7,server.robotnob7)

